
#ifndef _ISO_H_
#define _ISO_H_

#define MAX_LEN 270
#define ATR_LEN 20


typedef struct ISOCMD {
  uchar start;
  uchar klasse;
  uchar cmd;
  uchar param1;
  uchar param2;
  uchar len;
  uchar data;
} ISOCmd;


extern int i_iso_open(char *pc_dev);

extern int i_reset(uchar *atr);

extern int i_iso_close(void);

extern int i_card_inserted(void);

// Return: wenn > 0, laenge des telegrams mit Checksum
extern int i_DoCmd(ISOCmd *cmd, uchar *response, int maxresponse);

#endif // _ISO_H_
