/*
    sio.c
    Serial port input/output definitions
*/

#include "types.h"

extern int sio_init(int *i_fd, const char *pc_dev);
extern int sio_read (int i_fd, int i_timeout, int i_size, uchar * pc_data);
extern int sio_write (int i_fd, int i_delay, int size, const uchar * pc_data);
extern int sio_close (int i_fd);
extern int sio_card_inserted(int i_fd);
  // buffer flushen, 
	// reset puls ausloesen 
extern int sio_cardreset(int i_fd);


