/*
 * Softcam plugin to VDR (C++)
 *
 * This code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * Or, point your browser to http://www.gnu.org/copyleft/gpl.html
 */

#ifndef ___LOGGER_SECA_H
#define ___LOGGER_SECA_H

#include "logger.h"

// ----------------------------------------------------------------

class cLogSeca : public cLogSys {
private:
  int currId;
public:
  cLogSeca(int CardNum);
  virtual void Log(unsigned char *buffer, int n);
  virtual bool HaveCards(void);
  virtual int ParseCAT(unsigned char *buffer, int n, int sys, int id);
  virtual int Section(void);
  static bool LoadCards(const char *cfgdir);
  };

#endif //___LOGGER_SECA_H
