/*
 * Softcam plugin to VDR (C++)
 *
 * This code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * Or, point your browser to http://www.gnu.org/copyleft/gpl.html
 */

#include "i18n.h"

const tI18nPhrase Phrases[] = {
  { "Key logger",
    "Key Logger",
    "",
    "Key Logger",
    "",
    "",
    "Key Logger",
    "",
    "",
    "",
    "",
    "Logger klidion",
    "",
  },
  { "always on",
    "immer an",
    "",
    "sempre attivo",
    "",
    "",
    "toujours actif",
    "",
    "",
    "",
    "",
    "panta anixto",
    "",
  },
  { "non-recording on",
    "nicht-Aufnahme an",
    "",
    "attivo se non si sta registando",
    "",
    "",
    "actif sauf enregistrement",
    "",
    "",
    "",
    "",
    "anixto ektos egrafon",
    "",
  },
  { "Key logger timeout",
    "Key Logger Zeitgrenze",
    "",
    "Key Logger Timeout",
    "",
    "",
    "Temps max Key Logger",
    "",
    "",
    "",
    "",
    "Logger klidion xronoperiorismos",
    "",
  },
  { "Use fixed EMM PID",
    "Feste EMM Pid benutzen",
    "",
    "Usa un PID fisso per EMM",
    "",
    "",
    "Utiliser un PID EMM fixe",
    "",
    "",
    "",
    "",
    "Xrisimopiisi statherou EMM",
    "",
  },
  { "Fixed EMM PID",
    "Feste EMM PID",
    "",
    "EMM PID Fisso",
    "",
    "",
    "EMM PID fixe",
    "",
    "",
    "",
    "",
    "stathero EMM PID",
    "",
  },
  { "[Found keys]",
    "[Gefundene Keys]",
    "",
    "[Chiavi trovate]",
    "",
    "",
    "[Cls trouves]",
    "",
    "",
    "",
    "",
    "[vriskomena klidia]",
    "",
  },
  { "[New keys]",
    "[Neue Keys]",
    "",
    "[Nuove chiavi]",
    "",
    "",
    "[Nouvelles cls]",
    "",
    "",
    "",
    "",
    "[Nea klidia]",
    "",
  },
  { "Current key card",
    "Aktueller Key Karte",
    "",
    "Chiave in uso",
    "",
    "",
    "Cl courante",
    "",
    "",
    "",
    "",
    "Energo klidi kartas",
    "",
  },
  { "None",
    "Keiner",
    "",
    "Nessuno",
    "",
    "",
    "Aucune",
    "",
    "",
    "",
    "",
    "Kanena",
    "",
  },
  { "Reload files",
    "Dateien neu laden",
    "",
    "",
    "",
    "",
    "Recharger les fichiers",
    "",
    "",
    "",
    "",
    "Ksanadiavasma arxeion",
    "",
  },
  { "Really reload files?",
    "Dateien wirklich neu laden?",
    "",
    "Ricarica il file delle chiavi?",
    "",
    "",
    "Vraiment recharger les fichiers?",
    "",
    "",
    "",
    "",
    "Na diavastoun pali ta arxeia?",
    "",
  },
  { "Active! Can't reload files now",
    "Aktiv! Kann Dateien jetzt nicht neu laden",
    "",
    "Chiave in uso!",
    "",
    "",
    "Actif ! Je ne peux pas recharger maintenant",
    "",
    "",
    "",
    "",
    "Energo! Den ine dinato to ksanadiavasma",
    "",
  },
  { "SoftCAM",
    "SoftCAM",
    "",
    "SoftCAM",
    "",
    "",
    "SoftCAM",
    "",
    "",
    "",
    "",
    "SoftCAM",
    "",
  },
  { NULL }
  };
