/*
    sio.c
    Serial port input/output definitions
*/

typedef unsigned char uchar;
typedef int bool;

bool sio_init(int *i_fd, const char *pc_dev);
bool sio_read (int i_fd, int i_timeout, int i_size, uchar * pc_data);
bool sio_write (int i_fd, int i_delay, int size, const uchar * pc_data);
bool sio_close (int i_fd);
